︠e7587a6f-f66e-4bc8-93f1-404c9bb9d723︠
N_MAX = 10

def norm(set):
    return sqrt(sum([s^2 for s in set]))
    
def vector_to_dict(vect, vars):
    dict = {}
    n = 0
    for var in vars:
        dict[var] = vect[n]
        n = n+1
    return dict

def jacobi_matrix(equations, vars):
    n = len(equations)
    jacobi_list = [[equations[row].diff(vars[col]) for col in [0,..,n-1]] for row in [0,..,n-1]]
    return Matrix(jacobi_list)
    
def n_vector(v):
    for k in range(len(v)):
        v[k] = (v[k]).n()
    return v

def n_matrix(M):
    return Matrix([[(M[row][col]).n() for col in range(len(M.columns()))] for row in range(len(M.rows()))])
︡b3f3e538-6e42-4c6b-8652-027a21c3c789︡︡
︠7c7741d3-8b05-4dcd-b458-554c4362ad97︠
def fixpunktiteration(contraction, vars, xn, eps_min):
    n = 0
    convergence_delta = []
    eps = eps_min+1
    while eps > eps_min and n < N_MAX:
        #xn1 = gx.subs(vector_to_dict(xn, vars)).n()
        xn1 = [contraction[k].subs(vector_to_dict(xn, vars)).n() for k in range(len(vars))]
        eps = norm(vector(xn)-vector(xn1))
        xn = xn1
        convergence_delta.append(eps)
        n = n+1
    print "Fixpunkt-Lösung %d Iter.: x = %s" % (n, xn)
    return (xn, n, convergence_delta)
︡a063a451-c3d3-4833-82a5-83bea2606aa8︡︡
︠72c7e3f9-ad90-4412-9a8b-7bba1d7e1c13︠
def newtoniteration(equation, vars, xn, eps_min):
    n = 0
    xn = vector(xn)
    convergence_delta = []
    eps = eps_min+1
    J = jacobi_matrix(equation, vars)
    while eps > eps_min and n < N_MAX:
        g = vector([equation[k].subs(vector_to_dict(xn, vars)) for k in range(len(vars))])
        Jg = n_matrix(J.subs(vector_to_dict(xn, vars)))
        xn1=n_vector(xn-Jg.inverse()*g)
        
        xn = xn1;     
        eps=norm(g)
        convergence_delta.append(eps)
        n = n+1
    
    print "Newton-Lösung %d Iter.: x = %s" % (n, xn)
    return (xn,n,convergence_delta)
︡8f68d802-6a02-4ab9-97f2-2eb7434529f9︡︡
︠8192c2ed-7def-4603-96a1-119204c16d4a︠
var('x y z')

eps = 10^(-8)
contraction = [(cos(x)+2*y)/6,(sin(x)+x*y^2)/8]
equation = [cos(x)+2*y-6*x,sin(x)+x*y^2-8*y]
︡38caecfd-1a88-43be-b81b-50f2fbecac0a︡︡
︠e4d3fbc4-404d-4fba-b91f-353f032ff6a8︠
xn = [0,0]

print fixpunktiteration(contraction, [x,y], xn, eps)
print newtoniteration(equation, [x,y], xn, eps)
︡51483102-c0df-4922-8581-91842bf651bf︡{"stdout": "Fixpunkt-L\u00f6sung 10 Iter.: x = [0.171333626027552, 0.0213218191362875]\n([0.171333626027552, 0.0213218191362875], 10, [0.166666666666667, 0.0208652215157842, 0.00698120969359110, 0.000906223420507779, 0.000296752961852921, 0.0000413721138978165, 0.0000128892957593713, 1.94526559327172e-6, 5.70409136155520e-7, 9.27036527016171e-8])\nNewton-L\u00f6sung 4 Iter.: x = (0.171333648176476, 0.0213218141513725)\n((0.171333648176476, 0.0213218141513725), 4, [1, 0.0151056334257247, 3.31282967596466e-6, 1.63667795093475e-13])"}︡
︠c4d73444-33f4-4a6a-932b-29e66f5014b6︠
xn = [1,1]

print "Startwert: %s" % xn
fpi = fixpunktiteration(contraction, [x,y], xn, eps)
ni =newtoniteration(equation, [x,y], xn, eps)
︡2d4ea949-136d-4b5d-8864-4386491dc37f︡{"stdout": "Startwert: [1, 1]\nFixpunkt-L\u00f6sung 10 Iter.: x = [0.171333757409454, 0.0213218591582174]\nNewton-L\u00f6sung 5 Iter.: x = (0.171333648176476, 0.0213218141513725)"}︡
︠ab0ddaf4-2b5e-4980-8f07-b6d385843d20︠
def show_convergence(fpi, ni, xn):
    eco_fpi = [-log(fpi[k]-fpi[k+1]).n() for k in range(len(fpi)-1)]
    eco_ni = [-log(ni[k]-ni[k+1]).n() for k in range(len(ni)-1)]
    
    show(list_plot(eco_fpi)+list_plot(eco_ni, color='red'))
    
show_convergence(fpi[2], ni[2], ni[0])
︡a0bb92e1-7cc0-4949-8071-63d0c76de08c︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
